
!ABCIncludeFile

 OMIT('_EndOfInclude_',_RtBrSortPresent_)
_RtBrSortPresent_ EQUATE(1)

  include('ABBROWSE.INC')
  include('FldEqute.clw')
! -----------------------------------------------------------------------------------------
! include file for Run Time Sort Class 
! Written by        Dennis E. Evans
!
! Compiler          CW5a
!
! Updates           27 Feb 99
!                   Fixed key code bug
!                   Fixed TakeKey method bug
!
!                   2 Mar 99
!                   Added method AdjustSort (private)
!                   5 Apr 99
!                   Changed TakeKey method.
!                   10 Apr 99
!                   Added locators Step, Entry and Incremental
!                   28 Apr 99
!                   Fixed bug when no locator was present
!                   30 Apr 99
!                   Changed method headers for CW5a update
! -----------------------------------------------------------------------------------------
!
! define queue to hold standard field information, queue is used by the
! run time sort class and the filter class
!
StandFieldQueue         queue,type
FieldDisplay              string(40)        ! string to show user
FieldName                 string(40)        ! string to hold the field in string format
FieldActual               any               ! field reference
KeyNumber                 byte              ! sequence number of key, if any
CaseSensitive             byte              ! is this field case sensitive, used to format order criteria
FieldPicture              string(20)        ! picture format of entry field
FieldType                 byte              ! not used yet
FieldNumber               byte              ! which field in the browse is current
                        end  ! queue StandFieldQueue
! --------------------------------------------------------------------------------------
!
! define class to handle the standard fields
! very small class has one queue property and three methods, Init Kill and AddField
StandFields             class,MODULE('RtBrSort.CLW'),TYPE,LINK('RtBrSort.clw',_ABCLinkMode_),DLL(_ABCDllMode_)
Fields                    &StandFieldQueue       ! queue of fields to use
Init                      procedure
! allocates memory for queue property
Kill                      procedure
! deallocates memory of queue property
AddField                  procedure( *? any, string FldDisplay, string FldName, byte KNumber, byte UpCase, string FldPicture, byte FldType, byte FldNumber )
! Adds a field to the queue, with the any variable for use by the locator
                        end ! Class RtFields
! ---------------------------------------------------------------------------------------
! Class for NoKeyEntryLocator,
! Entry style locator for a tab without a key.
! *****************************
! DO NOT USE ON TAB WITH A KEY.
! *****************************
NoKeyEntryLocator CLASS(EntryLocatorClass),MODULE('RtBrSort.CLW'),type,LINK('RtBrSort.clw',_ABCLinkMode_),DLL(_ABCDllMode_)
FieldPrompt         byte,private        ! control equzte for prompt
Init                PROCEDURE(SIGNED Control = 0, SIGNED FldPrompt = 0, *? Free,BYTE NoCase = 0, <BrowseClass B>)
! init class, Note, the Free parameter is really a place holder during
! init.  The free element has no effect until the sort order is created.
ReSet               procedure,virtual
! reset the locator, hides/unhides the control and prompt
TakeAccepted        PROCEDURE,VIRTUAL,BYTE
! Take Accepted locator, does NOT call parent
SetHide             procedure( byte h ),private
! control is hidden when sort order is not active
                  end !class
! ---------------------------------------------
! derived Incremental style locator
! Incremental style locator for a tab without a key.
! *****************************
! DO NOT USE ON TAB WITH A KEY.
! *****************************
NoKeyIncrementLocator class(NoKeyEntryLocator),MODULE('RtBrSort.CLW'),type,LINK('RtBrSort.clw',_ABCLinkMode_),DLL(_ABCDllMode_)
TakeKey                   PROCEDURE,VIRTUAL,BYTE ! 1 for locator on value required
! returns false
                        end !if
! ---------------------------------------------------
! derived step style locator for a tab without a key.
! *****************************
! DO NOT USE ON TAB WITH A KEY.
! *****************************
NoKeyStepLocator    class(StepLocatorClass),MODULE('RtBrSort.CLW'),type,LINK('RtBrSort.clw',_ABCLinkMode_),DLL(_ABCDllMode_)
Init                  procedure(signed Control = 0, *? Free,BYTE NoCase = 0, <BrowseClass B>)
! init class, Note, the Free parameter is really a place holder during
! init.  The free element has no effect until the sort order is created.
TakeKey               procedure,virtual,byte ! 1 for locator on value required
! returns false
                    end !class
! -------------------------------------------------------------
! Define a queue to hold the information on each tab/sort order
! each tab that is added will be able to change sorts at run time
! most of this queue is used for housekeeping TabText, SortDisplay they are not really
! needed but add to the interface
!
RtSortTabs              queue,type
TabControl                byte          ! tab equate number
UseTabtext                byte          ! true if default text is to be used
TabText                   string(25)    ! default text for tab
SortStr                   string(150)   ! string to hold sort order
SortDisplay               string(100)   ! string to hold display for tab
                        end ! queue RtSortCtrls
! --------------------------------------------------------------------------------------
!
! class to handle run time sorts
! Run Time Browse Sort (RtBrSort) class allows the user to add fields to curennt sort order
! if browse is in record order then sort order is added
! 
RtBrSort               class(BrowseClass),MODULE('RtBrSort.CLW'),TYPE,LINK('RtBrSort.clw',_ABCLinkMode_),DLL(_ABCDllMode_)
Active                    byte,private          ! active sort boolean
AppendKeyCode             long,private          ! key code for sort button
SheetControl              byte,private          ! sheet equate number
SortControl               byte,private          ! button equate number
Sorts                     &RtSortTabs           ! queue refernce
StringControl             byte,private
ToTopAppend               byte,private          ! to top of list new sort
ToTopReset                byte,private          ! to top of list reset sort
ResetControl              byte,private          ! button equate number
ResetKeyCode              long,private          ! key code for clear buton
RtFields                  &StandFields          ! class reference
! method headers
AddTabSort                procedure( byte CtrlNum, string Txt, byte UseText )
! add a tab and the info for tab
AdjustSort                procedure(byte Force, byte ToTop, byte LocateFree),private
! reset sort after new sort selected or current sort cleared
ClearSort                 procedure(),private
! clears the sort string and reset to design time sort
GetNewSort                procedure(),private
! get new sort order, fills sort string and sort display
Init                      PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
InitControls              procedure(byte SortNum, byte ClrNum, byte ShtNum, byte StrCtrl, long SortKey = AltA, long ClearKey = AltR )
! init method, calls parent before seting properties
InitFields                procedure()
! init fields
Kill                      procedure(),virtual
! kill it
SetKeyCodes               procedure( long SortKey = AltA, long ClearKey = AltR )
! change the keycodes for the Rt sort controls
SetScrollAction           procedure( byte TopA = true, byte TopR = false )
! scroll to top on new sort order or reset,   Note the default values
SetSort                   procedure(BYTE NewOrder,BYTE Force),BYTE,VIRTUAL,PROC
! finds queue element for selected tab, calls parent
TakeEvent                 procedure(),virtual
! handles button press, calls parent
TakeKey                   PROCEDURE(),BYTE,PROC,VIRTUAL   ! 1 If action taken
! handles alt key for buttons, calls parent
UpdateTabs                procedure(),private
! updates tab messages when sort order changes or when window is updated
UpdateWindow              procedure(),virtual
! updates button controls, calls parent
                        end !Class RtSortOrder
! ------------------------------------------------------------------

_EndOfInclude_