#! Run time sort order templete for CW4 and CW5
#! -------------------------------------------------------------------------------------
#Template(RtSort, 'Run Time Sort'),family('ABC')
#! -------------------------------------------------------------------------------------
#! Runt Time Sort Order Extension
#! Written by       Dennis E. Evans
#! Date             12 Dec 98
#! Last update      19 Mar 99
#!     Tried to have pop up additions in the browse SetAlerts method
#!     rather than the window init.  Finally got the damN thing to work
#!     Added option to display message on string.
#!
#!     2 Mar,  Added clear to enable statement on default keycodes
#!     15 Mar  Added Reset option for browse and
#!             scroll option for sheet
#!     19 Mar  added code to remove prefix from field name for user display
#!     26 Mar  add locator tab and prompts
#!     10 Apr  added req attribute to browse name field
#!             added step locator prompts
#! -------------------------------------------------------------------------------------
#! Extension template to add run time sort orders to a browse
#! tab with no key.
#! -------------------------------------------------------------------------------------
#extension(RtSort, 'Run Time Sort'),REQ(BrowseBox(ABC))
#! ----------------------------------------------------------------
#sheet
#tab('General')
#display
#display('Extension template to allow run time sorting,')
#display('of a browse.  ')
#display
#display('Use on tabs with key/no key.')
#display('To use :')
#display(' 1.  Place two buttons on the browse screen.')
#display(' 2.  Change the class type for the browse.')
#display(' 3.  Fill in the template prompts.')
#endtab
#tab('&Tabs to use')
  #display
  #prompt('Display sort message on tabs',check),%TabMessage,default(1),at(10)
  #enable(%TabMessage = 0),clear
    #prompt('String control', from(%control, %ControlType = 'STRING')),%StringControlMsg,default(0),req
  #endenable
  #prompt('Sheet browse is on',from(%control, %ControlType = 'SHEET')),%SheetName
  #display
  #enable(%TabMessage),clear
    #prompt('Add scroll attribute to sheet',check),%SetScrollTabs,at(10),default(1)
    #enable(%SetScrollTabs),clear
      #prompt('Type scroll buttons', drop('None|Split|Joined')),%TypeScrollButtons,Default('Joined')
    #endenable
  #endenable
  #display
  #display('Select tabs')
  #button('Enter Tabs'),multi(%TabsToUse, %TabControlNumber & '('& %UseTabText &')'),INLINE
    #prompt('Tab to use', from(%Control, %ControlParent = %SheetName and %ControlType = 'TAB')),%TabControlNumber
    #prompt('Use tab text', drop('True|False')),%UseTabText,default('True')
    #display('True, will add append sort display fields to text.')
  #endbutton
#endtab
#tab('&Sort Controls')
  #display
  #prompt('Browse Name to Sort', @s75),%BrwNameToSort,req
  #display
  #display('Control button equates')
  #prompt('Button to edit sort ',from(%Control, %ControlType = 'BUTTON' and %Control <> %ResetButtonName)),%SortButtonName
  #prompt('Button to reset sort', from(%Control, %ControlType = 'BUTTON' and %Control <> %SortButtonName)),%ResetButtonName
  #display
  #prompt('Use default key codes',check),%DefaultKeyCodes,default(1),at(10)
  #enable(%DefaultKeyCodes = 0),clear
    #prompt('Key code sort button ', keycode),%SortButtonKeyCode,req
    #prompt('Key code reset button', keycode),%ResetSortButtonKeyCode,req
  #endenable
  #display
  #prompt('Add to popup menu', check),%AddToPopUpMenu,at(10)
  #enable(%AddToPopupMenu),clear
    #prompt('Place seperator before menu item', check),%AddSeperatorToPopUp,at(10)
  #endenable
  #display
  #prompt('Scroll to top on new sort', check),%ToTopAppend,at(10),default(1)
  #prompt('Scroll to top on reset sort', check),%ToTopReset,at(10),default(0)
#endtab
#tab('&Fields')
#display('Run time sort, fields to use.')
#display
#! ---------------------------------------------------------------------------------
#! set up for user input,   use a button with the multi and inline  attr.
#! the inline the will make sure that the fields are entered and deleted in a group
#! ---------------------------------------------------------------------------------
#display
  #button('Enter Sort Fields'),multi(%FieldsToSort, %FieldDisplay & ' ('& %FieldNameStr & ')' & '('& %CaseFormat &')' & '('& %KeyNumber &')' & '('& %BrwFieldNumber &')'),INLINE
    #prompt('Field Name', field),%FieldNameStr,req,unique
    #prompt('Display to user', @s40),%FieldDisplay
    #display('Leave blank to use field name, less prefix')
    #prompt('Case Sensitive', drop('True|False')),%CaseFormat,default('False')
    #prompt('Tab Sequence Number', spin(@n2, 0, 10)),%KeyNumber,default(0)
    #prompt('Queue sequence number',spin(@n2,1,50)),%BrwFieldNumber
    #button('Instructions')
      #display('1. Select the field to sort with.')
      #display('2. String to display to user.  Default is field')
      #display('name less prefix, assumes Pre:FieldName format.')
      #display('3. Field case sensitive.')
      #display('4. Tab sequence number, if field is part of a key.')
      #display('Fields used by the key from the first')
      #display('tab would all be 1, fields of keys from second tab.')
      #display('will be 2, etc...')
      #display('5. Queue sequence number, is the #n# for the queue field.')
      #display('(Order the field is displayed in List Box Formatter.)')
    #endbutton
  #endbutton
#! -------------------------------------------------------------------------------------------
#endtab
#tab('&Locator')
  #button('&Instructions')
    #display('Add locator control to screen, control is required')
    #display('for Entry and Incremental locators')
    #display('Add locator prompt to screen, prompt is optional')
    #display
    #display('Select locator type.')
    #display('Enter tab number, 2 for second tab, 3 for third ...')
    #display('Tab must be last tab on sheet.')
    #display('Locator must be on a tab that does not use a key')
    #display
    #display('Change locator name, if desired')
    #display('Select locator control, required')
    #display
    #display('Select field to be used as default Free Element')
    #display('Field has no effect, until sort order is active, field is a place holder')
    #display('for the class Init method')
    #display('Free element will change to the first field of the current sort order')
    #display
    #display('Note, Locator control and prompt are avaliable only when a sort order is active')
    #display('Both are hidden when using record order')
  #endbutton
  #display
  #prompt('Locator type', drop('None|Step|Entry|Incremental')),%RtLocatorType,default('None')
  #enable(%RtLocatorType <> 'None'),clear
    #prompt('Tab number ',spin(@n1,1,9)),%TabSortNumber,default(%SortOrder + 1)
    #prompt('Locator name ', @s50),%RtLocatorName,default('NoKeyLocator')
    #enable(%RtLocatorType = 'Entry')
      #prompt('Entry control', from(%Control, %ControlType = 'ENTRY')),%RtLocatorControl,req
    #endenable
    #enable(%RtLocatorType = 'Incremental')
      #prompt('String control', from(%Control, %ControlType = 'STRING')),%RtLocatorControl,req
    #end
    #enable(%RtLocatorType <> 'Step' and %RtLocatorType <> 'StepAndEntry'),clear
      #prompt('Locator prompt', from(%Control, %ControlType = 'PROMPT')),%RtLocatorPrompt,default(0)
    #endenable
    #prompt('Default Free Element', field),%RtDefaultFree,req
  #endenable
#endtab
#endsheet
#atstart
#declare(%BrwFieldEquate)
#declare(%LocalCount,long)
#declare(%NormString, long)
#set(%NormString, 2)
#declare(%UpperString, long)
#set(%UpperString, 3)
#declare(%CapString, long)
#set(%CapString, 4)
#comment(65)                        #! set location for generated comments
#endat
#! ------------------------------------
#! place the code to init the RtSort class and add the fields
#! priority 8140
#! -------------------------------------------------------------------------
#at(%LocalDataClasses),priority(10000)
#if(%RtLocatorType <> 'None')
! No key locator
  #case(%RtLocatorType)
    #of('Step')
%RtLocatorname          NoKeyStepLocator
    #of('Entry')
%RtLocatorname          NoKeyEntryLocator
    #of('Incremental')
%RtLocatorname          NoKeyIncrementLocator
  #endcase
#endif
#endat
#at (%WindowManagerMethodCodeSection, 'Init', '(),BYTE'),PRIORITY(8140)
#! rather than change the shipping templates to allow the use of a diffrent
#! init method call, call the normal init method and then init the controls
! init control equates
#if (%DefaultKeyCodes)
%BrwNameToSort.InitControls( %SortButtonName, %ResetButtonName, %SheetName, %StringControlMsg )
#else
%BrwNameToSort.InitControls( %SortButtonName, %ResetButtonName, %SheetName, %StringControlMsg, %SortButtonKeyCode, %ResetSortButtonKeyCode) 
#endif
! set action for scroll to top option (append and reset)
%BrwNameToSort.SetScrollAction( %ToTopAppend, %ToTopReset )
  #if(%RtLocatorType <> 'None')
%BrwNameToSort.SetSort(%TabSortNumber - 1)
%BrwNameToSort.AddLocator(%RtLocatorName)
  #if(%RtLocatortype = 'Step')
! init Step locator
%RtLocatorName.Init(, %RtDefaultFree, 1, %BrwNameToSort)
  #else
! init locator
%RtLocatorName.Init(%RtLocatorControl, %RtLocatorPrompt, %RtDefaultFree, 1, %BrwNameToSort)
  #end
%BrwNameToSort.SetSort(%TabSortNumber)
  #endif
#set(%LocalCount, 0)
! --------------------------------------------------------------------
! Add fields to sort with to the queue
#for(%FieldsToSort)         #! loop thru the fields
#if (%FieldDisplay = '')    #! if user left display blank, default to field name less prefix
  #set(%FieldDisplay, sub(%FieldNameStr, instring(':', %FieldNameStr, 1, 1) + 1, len(clip(%FieldNameStr))))
#end
#find(%Field, %FieldNameStr)
#set(%BrwFieldEquate, %NormString)
#for(%FieldScreenControl)
  #if(instring('CAP', %FieldScreenControl, 1, 1))
    #set(%BrwFieldEquate, %CapString)
    #break
  #endif
  #if(instring('UPR', %FieldScreenControl, 1, 1))
    #set(%BrwFieldEquate, %UpperString)
    #break
  #endif
#endfor
#set(%LocalCount, %LocalCount + 1)
#if(%BrwFieldNumber = 0)
%BrwNameToSort.RtFields.AddField(%FieldNameStr, '%FieldDisplay', '%FieldNameStr', %KeyNumber, %CaseFormat, '%FieldDisplayPicture', %BrwFieldEquate, %LocalCount)
#else
%BrwNameToSort.RtFields.AddField(%FieldNameStr, '%FieldDisplay', '%FieldNameStr', %KeyNumber, %CaseFormat, '%FieldDisplayPicture', %BrwFieldEquate, %BrwFieldNumber)
#endif
#endfor
! ----------------------------------------------
! Add tabs for Run Time Sort
#for(%TabsToUse)         #! loop thru the tabs
%BrwNameToSort.AddTabSort( %TabControlnumber, %TabControlNumber{prop:text}, %UseTabText )
#endfor
! Set selected scroll attribute for tabs, if any
#if(%SetScrollTabs <> 'None')
  #if(%TypeScrollButtons = 'Joined')
%SheetName{prop:join} = true
  #else
%SheetName{prop:hscroll} = true
  #endif
#endif
! -------------------------------------------------
#endat
#at(%BrowserMethodCodeSection,%ActiveTemplateParentInstance,'SetAlerts'),priority(7500)
#if(%AddToPopUpMenu)
! ----------------------------------------------------------
! add popup menu option
#if (%AddSeperatorToPopUp)
! add seperator before new options
Self.Popup.AddItem('-')
#endif
! add RT sort popups
Self.Popup.AddItemMimic('SortButton', %SortButtonName)
Self.Popup.AddItemMimic('ResetSortButton', %ResetButtonName)
! ----------------------------------------------------------
#endif
#endat
